/// @file

#if !defined cmif_DefaultScore_h
#define cmif_DefaultScore_h

	/// Names
namespace cmif
{
		/// This is a base class for objects requiring a default score.
	template <typename T>
	class DefaultScore
	{
	public:

		DefaultScore(const T& t = T(), bool b = false);
		DefaultScore(const DefaultScore& rhs);

		void swap(DefaultScore& rhs);

		bool operator==(const DefaultScore& rhs) const;
		bool hasDefaultScore() const;
		const T& defaultScore() const;

		/// Set the default score
		/// @param d The default score
		virtual void defaultScore(const T& d);

		/// Set whether the factor uses the default score
		/// @param b true iff the factor uses the default score
		virtual void hasDefaultScore(bool b);

	private:

		bool hasDefaultScore_;
		T defaultScore_;
	};

}

#include "DefaultScore.cpp"

#endif // cmif_DefaultScore_h
